//+------------------------------------------------------------------+
//|                                                     EAtester.mq4 |
//|                                         Copyright 2019, Andre Le |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2019, Andre Le"
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict

#define SUP_Dif1 0
#define SUP_Dif2 1
#define RES_Dif1 2
#define RES_Dif2 3
#define SR_MKT_TREND 4

extern ENUM_TIMEFRAMES SuppResisChkTF1=PERIOD_M30;
extern ENUM_TIMEFRAMES SuppResisChkTF2=PERIOD_H1;
extern int inpSRlookback1=100; //look back 100 bars in first (small) time fame
extern int inpSRlookback2=200; //look back 200 bars in 2nd (large) timeframe
extern int inpSRshift1=20; //TF1: shift 20 bars from current bar
extern int inpSRshift2=20; //TF2: shift 20 bars from current bar 

//Best to have no trade within 80 - 110 pips around the S&R



string S1ObjLineName = "Supp1"; 
string S2ObjLineName = "Supp2";
string R1ObjLineName = "Resis1"; 
string R2ObjLineName= "Resis2";

string S1ObjLblName = "Supp1Lbl"; 
string S2ObjLblName = "Supp2Lbl";
string R1ObjLblName = "Resis1Lbl"; 
string R2ObjLblName= "Resis2Lbl";

string S1ObjLblTxt = "Supp1"; 
string S2ObjLblTxt = "Supp2";
string R1ObjLblTxt = "Resis1"; 
string R2ObjLblTxt= "Resis2";


color S1clr = clrBlue; color S2clr = clrBlue; color R1clr=clrRed; color R2clr=clrRed;
double rates_tf1[][6];
double rates_tf2[][6];
datetime TimeArray_1H[],TimeArray_30M[]; //declare the TimeArray

double SRoutputArrayCur[];
double SRoutputArray[1][5]; //1st array: bar amount
                          //2nd array: 1: SUP_Dif1, 2: RES_Dif1, 3: SUP_Dif2, 4: RES_Dif2, 5: BUY | BUY_REVERSAL | SELL | SELL_REVERSAL
extern int iCloseAveragePeriod = 5;
extern ENUM_MA_METHOD iCloseAverageMaMethod = MODE_EMA;
extern ENUM_APPLIED_PRICE iCloseAverageMaPrice = PRICE_CLOSE;
double iCloseAverage, iCloseTF1, iCloseTF2;

extern int HourShift = 400;
int i=1;
enum ENUM0_TREND{uptrend =1, downtrend=-1, sideway=0};

enum ENUM_MARKETTYPE{DOWNTREND_OVERSOLD=1, 
					DOWNTREND_NORMAL=2,
					SIDEWAY=3,
					SIDEWAY_UP=4,
					SIDEWAY_DOWN=5,
					UPTREND_NORMAL=6,
					UPTREND_OVERBOUGHT=7
					};
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
  //ArrayInitialize(SRoutputArray,0);

//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   ENUM_MARKETTYPE markettrend;
   ENUM0_TREND pricetrend=0; 
   iClose(NULL,SuppResisChkTF1,1);
   ArrayCopyRates(rates_tf1, Symbol(), SuppResisChkTF1); //Copy the Dayly bar price info
   ArrayCopyRates(rates_tf2, Symbol(), SuppResisChkTF2); //Copy the Dayly bar price info
   
   ArrayCopySeries(TimeArray_1H,MODE_TIME,Symbol(),SuppResisChkTF2);
   ArrayCopySeries(TimeArray_30M,MODE_TIME,Symbol(),SuppResisChkTF1);
   
    //Resizing array
   if(iTime(NULL,SuppResisChkTF1,0)<iTime(NULL,SuppResisChkTF2,0) || Time[0] < iTime(NULL,SuppResisChkTF2,0) ) 
   ArrayResize(SRoutputArray,iBars(NULL,MathMin(SuppResisChkTF1,SuppResisChkTF2))+1);
   else ArrayResize(SRoutputArray,iBars(NULL,MathMin(SuppResisChkTF1,SuppResisChkTF2)));

   double UsedClose;
   //Get values on new candle

      iCloseAverage = iMA(NULL,MathMin(SuppResisChkTF1, SuppResisChkTF2),iCloseAveragePeriod,0,iCloseAverageMaMethod,iCloseAverageMaPrice,1);
      iCloseTF1 =  iClose(NULL,SuppResisChkTF1,1); 
      if(iCloseTF1 > iCloseAverage)pricetrend=uptrend;
      else if(iCloseTF1 < iCloseAverage)pricetrend=downtrend; 
      else if(iCloseTF1 == iCloseAverage)pricetrend=sideway;
   
      //if(IsNewCandle(SuppResisChkTF2))
    if(IsNewCandle(MathMin(SuppResisChkTF1, SuppResisChkTF2)))
     {
      //SRoutputArray[1][SR_MKT_TREND]= sideway;

     for(i=5; i>=0; i--) //Recording the value of SUP1, SUP2, RES1, RES2 and markettrend of the last 5 bars 
     {
     SuppResisChk(SRoutputArrayCur, SuppResisChkTF1, SuppResisChkTF2, inpSRlookback1, inpSRlookback2, inpSRshift1+i, inpSRshift2+i) ;
      SRoutputArray[i][SUP_Dif1] = MarketInfo(NULL,MODE_ASK) - SRoutputArrayCur[0];
      SRoutputArray[i][SUP_Dif2] = MarketInfo(NULL,MODE_ASK) - SRoutputArrayCur[1];
      SRoutputArray[i][RES_Dif1] = MarketInfo(NULL,MODE_BID) - SRoutputArrayCur[2];
      SRoutputArray[i][RES_Dif2] = MarketInfo(NULL,MODE_BID) - SRoutputArrayCur[3];
        if(iCloseAverage< MathMin(SRoutputArrayCur[0],SRoutputArrayCur[1]))
            markettrend=DOWNTREND_OVERSOLD;
        else if (iCloseAverage<=SRoutputArrayCur[0] && iCloseAverage>SRoutputArrayCur[1])
            markettrend=DOWNTREND_NORMAL;
        else if (iCloseTF1>=SRoutputArrayCur[2] && iClose(NULL,SuppResisChkTF1,1)<SRoutputArrayCur[3])
            markettrend=UPTREND_NORMAL;
        else if (iCloseTF1>MathMax(SRoutputArrayCur[2], SRoutputArrayCur[3]))
            markettrend=UPTREND_OVERBOUGHT;
        else
         {
          if(pricetrend=uptrend)markettrend=SIDEWAY_UP;
          if(pricetrend=downtrend)markettrend=SIDEWAY_DOWN;
          if(pricetrend=sideway)markettrend=SIDEWAY;
         } 
         Print("markettrend", markettrend);

           //assign the markettrend to the 5th array of SRoutputArray[][]:

          if(markettrend!= SRoutputArray[i+1][SR_MKT_TREND]) 
          SRoutputArray[i][SR_MKT_TREND] = markettrend;
          else SRoutputArray[i][SR_MKT_TREND] = SRoutputArray[i+1][SR_MKT_TREND];
           
          }
       //Draw the support & resistance lines:
      ShowTrendline(0, S1ObjLineName, S1clr , Time[0], SRoutputArrayCur[0], HourShift, S1ObjLblName, S1ObjLblName + tf2txt(SuppResisChkTF1), S1clr,0) ;
      ShowTrendline(0, S2ObjLineName, S2clr , Time[0], SRoutputArrayCur[1], HourShift, S2ObjLblName, S2ObjLblName + tf2txt(SuppResisChkTF2), S2clr,0) ;
      ShowTrendline(0, R1ObjLineName, R1clr , Time[0], SRoutputArrayCur[2], HourShift, R1ObjLblName, R1ObjLblName + tf2txt(SuppResisChkTF1), R1clr,0) ;
      ShowTrendline(0, R2ObjLineName, R2clr , Time[0], SRoutputArrayCur[3], HourShift, R2ObjLblName, R2ObjLblName + tf2txt(SuppResisChkTF2), R2clr,0) ;
 
      }
   Comment("S1: ",  DoubleToStr(SRoutputArray[0][SUP_Dif1],2), 
           " S2: ", DoubleToStr(SRoutputArray[0][SUP_Dif2],2), 
           " R1: ", DoubleToStr(SRoutputArray[0][RES_Dif1],2) ,
           " R2: ",  DoubleToStr(SRoutputArray[0][RES_Dif2],2), "\n",
           "Trend status: " , trendtotxt(SRoutputArray[1][SR_MKT_TREND])
           );


  }
//+------------------------------------------------------------------+
string trendtotxt(int trend)
  {
  string txt;
   switch(trend)
   {
   case DOWNTREND_OVERSOLD: txt = "DOWNTREND OVERSOLD"; break;
   case DOWNTREND_NORMAL: txt = "DOWNTREND NORMAL"; break;
   case SIDEWAY_DOWN: txt = "SIDEWAY DOWN"; break;
   case SIDEWAY: txt = "SIDEWAY"; break;
   case SIDEWAY_UP: txt = "SIDEWAY UP"; break;
   case UPTREND_NORMAL: txt = "UPTREND NORMAL"; break;
   case UPTREND_OVERBOUGHT: txt = "UPTREND OVERBOUGHT"; break;
   }
      return(txt);
  }

int SuppResisChk(double &inpArray[], ENUM_TIMEFRAMES TF1, ENUM_TIMEFRAMES TF2,
                     int count1, int count2, int shift1, int shift2 
                     )
   {
   ArrayResize(inpArray,4);
   
   
   
   //TimeArray_1H[shift2]
   if(iLowest(NULL,TF1,MODE_LOW,count1,0)!=-1
      && iLowest(NULL,TF2,MODE_LOW,count2,0)!=-1
      )
      {
   //Support resistant base on iHighest and Lowest
   inpArray[0] =  rates_tf1[iLowest(NULL,TF1,MODE_LOW,count1,shift1)][2];
   //Print("count2: ", count2, "shift2: ", shift2, " ", rates_tf2[iLowest(NULL,TF2,MODE_LOW,100,20)][2]); 
   inpArray[1] =  rates_tf2[iLowest(NULL,TF2,MODE_LOW,count2,shift2)][2];
   inpArray[2] =  rates_tf1[iHighest(NULL,TF1,MODE_HIGH,count1,shift1)][3]; 
   inpArray[3] =  rates_tf2[iHighest(NULL,TF2,MODE_HIGH,count2,shift2)][3];
   
   //Print("Supp1: ", Supp1, ", Supp2: ", Supp2, " ,Resis1:", Resis1, " ,Resis2 ", Resis2);
   //Comment("S1: ",  inpArray[0], " S2: ", inpArray[1], " R1: ", inpArray[2], " R2: ",  inpArray[3]);
   return(0);
   }
   else
   {
   Comment("Error in computing the support and resistence ...");
   GetLastError(); return(-1);}
   }

int ShowTrendline(long Chart_ID, string TrendObjLineName,  //Trendline object attr.
                     color TrendObjclr , datetime TrendObjStartTime,
                     double TrendObjprice, long linelength,
					 string TrendObjLabelName, string TrendObjLabelText, color clrObjLabel, //Trendline label text
					 long lineshift
					 )
{
   long timeshifts, beginner, timeshift;
	switch (Period())
   {
      case PERIOD_M1:  {timeshifts=60; beginner=Hour()*60;} break;
      case PERIOD_M5:  {timeshifts=300; beginner=Hour()*12;} break;
      case PERIOD_M15: {timeshifts=900; beginner=Hour()*4;} break;
      case PERIOD_M30: {timeshifts=1800; beginner=Hour()*2;} break;
      case PERIOD_H1:  {timeshifts=3600; beginner=Hour()*1;} break;
      case PERIOD_H4:  {timeshifts=14400; beginner=Hour()*0.25;} break;
      case PERIOD_D1:  {timeshifts=86400; beginner=Hour()*0;} break;
    }   

      timeshift=timeshifts*linelength;
   //display the line object
      if (ObjectFind(TrendObjLineName) != 0) 
     {
      ObjectCreate(TrendObjLineName,OBJ_TREND,0,TrendObjStartTime+timeshift, TrendObjprice, TrendObjStartTime-timeshift,TrendObjprice);
      ObjectSet(TrendObjLineName,OBJPROP_COLOR,TrendObjclr);
      ObjectSet(TrendObjLineName,OBJPROP_WIDTH,2);
      ObjectSet(TrendObjLineName,OBJPROP_RAY,false);
     }
     else
     {
     ObjectMove(TrendObjLineName, 0,TrendObjStartTime-(lineshift*timeshifts)+timeshift,TrendObjprice);
     ObjectMove(TrendObjLineName, 1,TrendObjStartTime-(lineshift*timeshifts)-timeshift,TrendObjprice);
     }
	 
	
if(ObjectFind(TrendObjLabelName) != 0)
      {
      ObjectCreate(TrendObjLabelName, OBJ_TEXT, 0, TrendObjStartTime-timeshift, TrendObjprice);
      ObjectSetText(TrendObjLabelName, TrendObjLabelText, 8, "Verdana", clrObjLabel);
      Print("***Line create success ");
      }
      else
      {
      ObjectMove(TrendObjLabelName, 0, TrendObjStartTime-timeshift, TrendObjprice);
      } 
   return(0);
}	 


datetime StrLocalTimeToServerTime(string localTime)
{
   datetime LocalTimeDT = StrToTime(localTime);
   double TimeDiff = MathRound(TimeCurrent() -  TimeLocal());
   datetime ChartTime = LocalTimeDT + TimeDiff;
   return(ChartTime);
}

int dummyOrderSend(string sym, ENUM_ORDER_TYPE ordertyp, double Lots)
   {
   double vbid    = MarketInfo(sym,MODE_BID); 
   double vask    = MarketInfo(sym,MODE_ASK); 
   double vpoint  = MarketInfo(sym,MODE_POINT); 
   int    vdigits = (int)MarketInfo(sym,MODE_DIGITS); 
   int    vspread = (int)MarketInfo(sym,MODE_SPREAD);
   double entry;
   switch(ordertyp)
   {
   case OP_BUY: entry=vask; break;
   case OP_BUYLIMIT: entry=vask - 500*MarketInfo(sym,MODE_POINT); break;
   case OP_SELL: entry=vbid;
   case OP_SELLLIMIT: entry=vbid + 500*MarketInfo(sym,MODE_POINT);
   }
   if(OrderSend(sym,ordertyp,Lots,entry,3,0,0,"TestingOrder",clrRed)) return(0); else return(-1);
  }
  
bool IsNewCandle(int period)
 {
   static int BarsOnChart=0; //static ==> only initialized once, if global then ==> int BarsOnChart=0;
   if(iBars(NULL,period)==BarsOnChart)
   return(false);
   BarsOnChart = iBars(NULL,period); 
   return(true);
 }
 
     string tf2txt(int tf)
   {
      if(tf==PERIOD_M1) return("M1");
      if(tf==PERIOD_M5) return("M5");
      if(tf==PERIOD_M15) return("M15");
      if(tf==PERIOD_M30) return("M30");
      if(tf==PERIOD_H1) return("H1");
      if(tf==PERIOD_H4) return("H4");
      if(tf==PERIOD_D1) return("D1");
      if(tf==PERIOD_W1) return("W1");
      if(tf==PERIOD_MN1) return("MN1");
      //----
      return("??");
   }